#version 330

/**
 * This first defined out variable of the fragment shader defines
 * with which color the fragment is rendered:
 */
out vec4 fragment_color;

/**
 * The value of this variable comes from the vertex shader
 * (see 'out vec4 texCoord_from_vs;'). Note that input variables
 * in the fragment shader, which comes from the vertex shader,
 * are automatically interpolated.
 */
in vec2 texCoord_from_vs;

/**
 * Contains the elapsed time in seconds since the program
 * was started.
 */
uniform float time;

/**
 * Gives access to the 2D water image. The color of single pixels
 * can be read by using the texture-function using image coordinates.
 * (see last line of the main-function).
 */
uniform sampler2D waterImage;

/**
 * Should return a modified image coordinate, so that the image
 * is slowly moving towards the viewer. To do that, use the time
 * variable.
 *
 * @texCoord    This is an image coordinate as described in the
 *              assignment sheet.
 */
vec2 effect1(vec2 texCoord){
    // *TODO* (Exercise 2): Modifiy the image coord:
    return texCoord;
}

/**
 * Should return a modified image coordinate, so that the image
 * is alternately slightly stretched in some areas, while at the
 * same time it is slightly compressed in other areas.
 *
 * @texCoord    This is an image coordinate as described in the
 *              assignment sheet.
 */
vec2 effect2(vec2 texCoord){
    // *TODO* (Exercise 2): Modifiy the image coord:
    return texCoord;
}

/**
 * The main function of the fragment shader, which is executed
 * for every fragment.
 */
void main()
{
    // Applies effect1 and effect2 to the image coordinates:
    vec2 texCoord = effect1(effect2(texCoord_from_vs));

    // Reads the color of the image 'waterImage' at the image
    // coordinate 'texCoord' and set it as the fragment color:
    fragment_color = texture(waterImage, texCoord);
}
