// © 2022, CGVR (https://cgvr.informatik.uni-bremen.de/),
// Author: Andre Mühlenbrock (muehlenb@uni-bremen.de)

// Include this file only once when compiling:
#pragma once

// Include OpenGL3.3 Core functions:
#include <glad/glad.h>

// Include shader:
#include "Shader.h"

// Include our Vec4f class:
#include "Vec4f.h"



/**
 * A class for drawing lines.
 */
class LineDrawer
{
    // Pointer to Vertex Array Object (on GPU):
    GLuint vao = 0;

    // Pointer to vertex buffer:
    GLuint vbo = 0;

    // Shader to draw the lines:
    Shader shader;

public:
    LineDrawer();

    ~LineDrawer();

    void draw(Vec4f startPosition, Vec4f endPosition, Vec4f color, Mat4f modelMatrix);
};
